
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>我的Java开发学习之旅------&amp;gt;Java经典排序算法之归并排序 / 憋错料</title>

    <meta name="description" content="我的Java开发学习之旅------&amp;gt;Java经典排序算法之归并排序 一.归并排序 归并排序是建立在归并操作上的一种有效的排序算法,该算法是採用分治法(Divide and Conquer)的一个很典型的应用.将已有序的子序列合并,得到全然有序的序列.即先使每一个子序列有序.再使子序列段间有序.若将两个有序表合并成一个有序表.称为二路归并. 归并过程为:比較a[i]和a[j]的大小.若a[i]≤a[j],则将第一个有序表中的元素a[i]拷贝到r[k]中,并令i和k分别加上1.否则将第二个有序表中的元素a[j]拷贝到r[k]中,并令j和k分别加上1.如此循环下去.直">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">我的Java开发学习之旅------&amp;gt;Java经典排序算法之归并排序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一、归并排序</strong></p>
<p>归并<a href="http://baike.baidu.com/view/58783.htm" rel="external nofollow noreferrer">排序</a>是建立在归并操作上的一种有效的排序算法,该算法是採用分治法（Divide and Conquer）的一个很典型的应用。将已有序的子序列合并，得到全然有序的序列。即先使每一个子序列有序。再使子序列段间有序。若将两个有序表合并成一个有序表。称为二路<a href="http://baike.baidu.com/view/711818.htm" rel="external nofollow noreferrer">归并</a>。</p>
<p>归并过程为：比較a[i]和a[j]的大小。若a[i]≤a[j]，则将第一个有序表中的元素a[i]拷贝到r[k]中，并令i和k分别加上1。否则将第二个有序表中的元素a[j]拷贝到r[k]中，并令j和k分别加上1。如此循环下去。直到当中一个有序表取完，然后再将还有一个有序表中剩余的元素拷贝到r中从下标k到下标t的单元。归并排序的算法我们通经常使用递归实现，先把待排序区间[s,t]以中点二分，接着把左边子区间排序，再把右边子区间排序，最后把左区间和右区间用一次归并操作合并成有序的区间[s,t]。</p>
<p>二、<strong>归并操作</strong></p>
<p><strong><img src="http://img.blog.csdn.net/20150624181543873?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvb3V5YW5nX3Blbmc=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center"></p>
<p></strong></p>
<p><strong>三、两路归并算法</strong></p>
<p><strong>1、算法基本思路</p>
<p>　设两个有序的子文件(相当于输入堆)放在同一向量中相邻的位置上：R[low..m]，R[m&#043;1..high]。先将它们合并到一个局部的暂存向量R1(相当于输出堆)中，待合并完毕后将R1复制回R[low..high]中。</p>
<p>（1）合并过程</p>
<p>　合并过程中，设置i，j和p三个指针。其初&#20540;分别指向这三个记录区的起始位置。</p>
<p>合并时依次比較R[i]和R[j]的keyword，取keyword较小的记录拷贝到R1[p]中，然后将被复制记录的指针i或j加1，以及指向复制位置的指针p加1。</p>
<p>　反复这一过程直至两个输入的子文件有一个已所有复制完成(最好还是称其为空)，此时将还有一非空的子文件里剩余记录依次拷贝到R1中就可以。</p>
<p>（2）动态申请R1</p>
<p>　实现时。R1是动态申请的。由于申请的空间可能非常大。故须增加申请空间是否成功的处理。</p>
<p>2、归并算法</p>
<p></strong></p>
<pre> void Merge(SeqList R，int low。int m，int high)
    {//将两个有序的子文件R[low..m)和R[m+1..high]归并成一个有序的
     //子文件R[low..high]
     int i=low，j=m+1，p=0； //置初始值
     RecType *R1； //R1是局部向量。若p定义为此类型指针速度更快
     R1=(ReeType *)malloc((high-low+1)*sizeof(RecType))。
     if(! R1) //申请空间失败
       Error(&quot;Insufficient memory available!&quot;)。
     while(i&lt;=m&amp;&amp;j&lt;=high) //两子文件非空时取其小者输出到R1[p]上
       R1[p++]=(R[i].key&lt;=R[j].key)?R[i++]：R[j++]。
     while(i&lt;=m) //若第1个子文件非空，则复制剩余记录到R1中
       R1[p++]=R[i++]。
     while(j&lt;=high) //若第2个子文件非空，则复制剩余记录到R1中
       R1[p++]=R[j++]。
     for(p=0，i=low；i&lt;=high。p++。i++)
       R[i]=R1[p]；//归并完毕后将结果复制回R[low..high]
    } //Merge</pre>
<p><strong>四、归并排序</strong></p>
<p><strong>归并排序有两种实现方法：自底向上和自顶向下。以下说说</strong><strong>自顶向下的方法&nbsp;<br />
 &nbsp; &nbsp;</strong></p>
<p><strong>（1）分治法的三个步骤</p>
<p>设归并排序的当前区间是R[low..high]，分治法的三个步骤是：</p>
<p>①分解：将当前区间一分为二，即求分裂点</p>
<p>②求解：递归地对两个子区间R[low..mid]和R[mid&#043;1..high]进行归并排序。</p>
<p>③组合：将已排序的两个子区间R[low..mid]和R[mid&#043;1..high]归并为一个有序的区间R[low..high]。</p>
<p>递归的终结条件：子区间长度为1（一个记录自然有序）。</p>
<p>（2）详细算法</p>
<p></strong></p>
<pre>void MergeSortDC(SeqList R，int low。int high)
     {//用分治法对R[low..high]进行二路归并排序
       int mid；
       if(low&lt;high){//区间长度大于1
          mid=(low+high)/2； //分解
          MergeSortDC(R。low，mid); //递归地对R[low..mid]排序
          MergeSortDC(R。mid+1，high)； //递归地对R[mid+1..high]排序
          Merge(R，low，mid，high)； //组合，将两个有序区归并为一个有序区
        }
     }//MergeSortDC</pre>
<p>（3）算法MergeSortDC的运行过程</p>
<p>算法MergeSortDC的运行步骤例如以下图所看到的的递归树。</p>
<p><img src="http://img.blog.csdn.net/20150624182402320?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvb3V5YW5nX3Blbmc=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<p><strong>五、算法分析</p>
<p>1、稳定性</p>
<p>　归并排序是一种稳定的排序。</strong></p>
<p><strong></p>
<p>2、存储结构要求</p>
<p>　可用顺序存储结构。也易于在链表上实现。</strong></p>
<p><strong></p>
<p>3、时间复杂度</p>
<p>　对长度为n的文件，需进行 趟二路归并，每趟归并的时间为O(n)。故其时间复杂度不管是在最好情况下还是在最坏情况下均是O(nlgn)。</strong></p>
<p><strong></p>
<p>4、空间复杂度</p>
<p>　 须要一个辅助向量来暂存两有序子文件归并的结果。故其辅助空间复杂度为O(n)。显然它不是就地排序。</p>
<p>注意：</p>
<p>　若用单链表做存储结构。非常easy给出就地的归并排序。</strong></p>
<p><strong></p>
<p>5、比較操作的次数介于(nlogn) / 2和nlogn - n &#043; 1。</strong></p>
<p><strong></p>
<p>6、赋&#20540;操作的次数是(2nlogn)。归并算法的空间复杂度为：0 (n)</strong></p>
<p><strong></p>
<p>7、归并排序比較占用内存。但却是一种效率高且稳定的算法。</p>
<p></strong></p>
<p><strong></p>
<p></strong></p>
<p><strong>六、代码实现</strong></p>
<p><strong></strong></p>
<pre>public class MergeSortTest {

	public static void main(String[] args) {
		int[] data = new int[] { 2, 4, 7, 5, 8, 1, 3, 6 };
		System.out.print(&quot;初始化：\t&quot;);
		print(data);
		System.out.println(&quot;&quot;);

		mergeSort(data, 0, data.length - 1);

		System.out.print(&quot;\n排序后:  \t&quot;);
		print(data);
	}

	public static void mergeSort(int[] data, int left, int right) {
		if (left &gt;= right)
			return;
		//两路归并
		// 找出中间索引
		int center = (left + right) / 2;
		// 对左边数组进行递归
		mergeSort(data, left, center);
		// 对右边数组进行递归
		mergeSort(data, center + 1, right);
		// 合并
		merge(data, left, center, center + 1, right);
		System.out.print(&quot;排序中:\t&quot;);
		print(data);
	}

	/**
	 * 将两个数组进行归并。归并前面2个数组已有序。归并后依旧有序
	 *
	 * @param data
	 *            数组对象
	 * @param leftStart
	 *            左数组的第一个元素的索引
	 * @param leftEnd
	 *            左数组的最后一个元素的索引
	 * @param rightStart
	 *            右数组第一个元素的索引
	 * @param rightEnd
	 *            右数组最后一个元素的索引
	 */
	public static void merge(int[] data, int leftStart, int leftEnd,
			int rightStart, int rightEnd) {
		int i = leftStart;
		int j = rightStart;
		int k = 0;
		// 暂时数组
		int[] temp = new int[rightEnd - leftStart + 1]; //创建一个暂时的数组来存放暂时排序的数组
		// 确认切割后的两段数组是否都取到了最后一个元素
		while (i &lt;= leftEnd &amp;&amp; j &lt;= rightEnd) {
			// 从两个数组中取出最小的放入暂时数组
			if (data[i] &gt; data[j]) {
				temp[k++] = data[j++];
			} else {
				temp[k++] = data[i++];
			}
		}
		// 剩余部分依次放入暂时数组（实际上两个while仅仅会运行当中一个）
		while (i &lt;= leftEnd) {
			temp[k++] = data[i++];
		}
		while (j &lt;= rightEnd) {
			temp[k++] = data[j++];
		}
		k = leftStart;
		// 将暂时数组中的内容拷贝回原数组中 // （原left-right范围的内容被复制回原数组）
		for (int element : temp) {
			data[k++] = element;
		}
	}

	public static void print(int[] data) {
		for (int i = 0; i &lt; data.length; i++) {
			System.out.print(data[i] + &quot;\t&quot;);
		}
		System.out.println();
	}
}</pre>
<p>七、执行结果</p>
<p><strong></p>
<p></strong></p>
<pre>初始化：	2	4	7	5	8	1	3	6	

排序中:	2	4	7	5	8	1	3	6
排序中:	2	4	5	7	8	1	3	6
排序中:	2	4	5	7	8	1	3	6
排序中:	2	4	5	7	1	8	3	6
排序中:	2	4	5	7	1	8	3	6
排序中:	2	4	5	7	1	3	6	8
排序中:	1	2	3	4	5	6	7	8	

排序后:  	1	2	3	4	5	6	7	8
</pre>
<p><strong></strong></p>
<p>==================================================================================================</p>
<p><strong>&nbsp; 作者：欧阳鹏 &nbsp;欢迎转载。与人分享是进步的源泉！</strong></p>
<p><strong>&nbsp; 转载请保留原文地址：<a href="http://blog.csdn.net/ouyang_peng" rel="external nofollow noreferrer">http://blog.csdn.net/ouyang_peng</a></strong></p>
<p>==================================================================================================</p>
<p><img><br />
<br />watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvb3V5YW5nX3Blbmc=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"  style="border:none; max-width:100%; font-size:24px; line-height:24px; text-indent:2em"&gt;</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 18:36:44 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>我的Java开发学习之旅------&amp;gt;Java经典排序算法之归并排序的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGp6xG0.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;解惑Java进行三目运算时的自动类型转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天看到两个面试题,居然都做错了.通过这两个面试题,也加深对三目运算是的自动类型转换的理解. 题目1.以下代码输出结果是(). public class Test { public static void main(String[] args) { int a=5; System.out.println(&quot;value is :&quot;+((a&lt;5)?10.9:9)); } } A.编译错误     B.10.9           C.9           D.以上答案都不对 我不假			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e5rNv0.html" rel="bookmark">矿Java开发学习之旅------&amp;amp&semi;gt&semi;Java排序算法经典的二分法插入排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.折半插入排序(二分插入排序) 将直接插入排序中寻找A[i]的插入位置的方法改为採用折半比較,就可以得到折半插入排序算法.在处理A[i]时,A[0]--A[i-1]已经按关键码值排好序.所谓折半比較,就是在插入A[i]时,取A[i-1/2]的关键码值与A[i]的关键码值进行比較,假设A[i]的关键码值小于A[i-1/2]的关键码值.则说明A[i]仅仅能插入A[0]到A[i-1/2]之间.故能够在A[0]到A[i-1/2-1]之间继续使用折半比較:否则仅仅能插入A[i-1/2]到A[i-1]之间			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0enAYJ3.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;Java使用ObjectOutputStream和ObjectInputStream序列号对象相关问题解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天用ObjectOutputStream和ObjectInputStream进行对象序列化话操作的时候,报了java.io.EOFException异常. 异常代码如下: java.io.EOFException at java.io.ObjectInputStream$BlockDataInputStream.peekByte(ObjectInputStream.java:2554) at java.io.ObjectInputStream.readObject0(ObjectInputSt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPwYkD4.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;Java NIO 报java&period;nio&period;charset&period;MalformedInputException&colon; Input length &equals; 1异常</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在使用Java NIO的Channel和Buffer进行文件操作时候,报了java.nio.charset.MalformedInputException: Input length = 1异常,具体如下: java.nio.charset.MalformedInputException: Input length = 1 at java.nio.charset.CoderResult.throwException(CoderResult.java:260) at java.nio.char			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jAPXVM.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;在Dos环境下Java内部类的编译和运行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				习惯了在IDE工具上进行代码编写,连最基本的Javac命令和Java命令都忘记的差不多了,今天对一个Java内部类进行编译和运行的时候,就出糗了.IDE是把双刃剑,它可以什么都帮你做了,你只要敲几行代码,点几下鼠标,程序就跑起来了,用起来相当方便.你不用去关心它后面做了些什么,执行了哪些命令,基于什么原理.然而也是这种过分的依赖往往让人散失了最基本的技能,当到了一个没有IDE的地方,你便觉得无从下手,给你个代码都不知道怎么去跑. 首先我在C盘上编写了一个InnerClassTest.java代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qZYX3.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;System&period;nanoTime与System&period;currentTimeMillis的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先来看一道题:下面代码的输出结果是什么? import java.util.HashMap; import java.util.Map; public class HashMapTest { public static void main(String[] args) { Map&lt;String, String&gt; map=new HashMap&lt;String, String&gt;(); map.put(String.valueOf(System.currentTimeMillis())			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35qZaR3.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;Java String对象作为参数传递的问题解惑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				又是一道面试题,来测试你的Java基础是否牢固. 题目:以下代码的运行结果是? public class TestValue { public static void test(String str) { str=&quot;World&quot;; //代码3 } public static void main(String[] args) { String string = &quot;Hello&quot;; //代码1 test(string); //代码2 System.out.println(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzAbnl4.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;使用循环递归算法把数组里数据数组合全部列出</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面试题如下:把一个数组里的数组合全部列出,比如1和2列出来为1,2,12,21. (面试题出自&lt;Java程序员面试宝典&gt;) 代码如下: import java.util.Arrays; import java.util.LinkedList; import java.util.List; /** * 把一个数组里的数组集合全部列出,比如1和2列出来为1,2,12,21 */ public class ListAll { public static void main(String[] args			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41wAEv0.html" rel="bookmark">我的Java开发学习之旅------&amp;gt&semi;求字符串中出现次数最多的字符串以及出现的次数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				金山公司面试题:一个字符串中可能包含a~z中的多个字符,如有重复,如String data=&quot;aavzcadfdsfsdhshgWasdfasdf&quot;,求出现次数最多的那个字母及次数,如有多个重复的则都求出. 此题的解题思路如下: 引入TreeSet:通过集合快速找到所有出现过的字符串 引入ArrayList:为了快速排序,再通过StringBuffer生成排序后的字符串 通过String的indexOf方法和lastIndexOf方法来计算每个字符串出现的次数最大值 使用HashMap			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41DjG3.html" rel="bookmark" class="title">centos 7 安装mono 和 monodevelop</a>
					<div>
						本次所有操作在root模式下 1.执行  rpm --import &quot;http://keyserver.ubuntu.com/pks/lookup?op=get&amp;search=0x3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMm8bX4.html" rel="bookmark" class="title">Python的变量以及类型</a>
					<div>
						1.程序是用来处理数据的,变量就是用来存储数据的  num1 = 100 2.为了更充分的利用内存空间以及更有效率的管理内存,变量是有不同的类型 3.怎样知道一个变量的类型呢? 3.1 在python ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0nDwo4.html" rel="bookmark" class="title">新浪微博客户端&lpar;41&rpar;-切换表情键盘</a>
					<div>
						DJComposeViewController.m #pragma mark - 切换键盘 - (void)switchKeyboard { // textView.inputView 代表的就是键盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eGlJ4.html" rel="bookmark" class="title">51CTO博客后台为什么不能添加了博文分类了？？？</a>
					<div>
						目前我的51CTO博客后台分类有20个,想要再添加其他分类,但是无法添加,51CTO能不能说说这是为什么					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXn2j3.html" rel="bookmark" class="title">利用BitLocker和VHD实现共享文件加密</a>
					<div>
						Windows7企业版或旗舰版系统提供加密功能有BitLocker与EFS.EFS加密的对象是NTFS分区中单独的文件或文件夹,而BitLocker加密的对象是整个分区.EFS设置相对复杂,BitLo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02mzKAM.html" rel="bookmark" class="title">【Node&period;js基础篇】（十）使用net模块和Readline模块实现Socket通信</a>
					<div>
						Node.js的socket通信和C++.Java的非常相像,学过这两种语言的socket通信的同学可以很快就掌握好Node.js的socket通信.下面我们以实现一个Echo服务器的服务端和客户端为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2Wyw3.html" rel="bookmark" class="title">基于密度聚类的DBSCAN算法</a>
					<div>
						根据各行业特性,人们提出了多种聚类算法,简单分为:基于层次.划分.密度.图论.网格和模型的几大类. 其中,基于密度的聚类算法以DBSCAN最具有代表性. 假设有如下图的一组数据, 生成数据的R代码如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MB1Lvj4.html" rel="bookmark" class="title">页面中用Context&period;Handler传递</a>
					<div>
						最近被WCF弄得身心疲惫.今天抽空看了一下页面传值的一些技巧.传统的cookie session 什么的就不介绍了 今天介绍Context的用法 首先要应用using System.Runtime.R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47DxqoM.html" rel="bookmark" class="title">抽象方法实现多态</a>
					<div>
						抽象方法在抽象类中.抽象类中可以有非抽象成员,子类可以来使用. 抽象类中,申明的构造函数,也可以让子类通过base来调用. 抽象类只能是父类,但是没有规定抽象类必须要有子类 抽象方法既然是抽象的,子类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nk5ov3.html" rel="bookmark" class="title">IS支持解析json</a>
					<div>
						1． MIME设置:在IIS的站点属性的HTTP头设置里,选MIME 映射中点击”文件类型”-”新类型”,添加一个文件类型:关联扩展名:*.json内容类型(MIME):application/x-j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41BmgJM.html" rel="bookmark" class="title">5月20日重点：当请求的参数是动态的形式时，原生app与h5页面之间数据交互的方法</a>
					<div>
						方案一: 1.app在打开H5页面的时候,把需要给的参数,以get的形式,放在H5的url中. 2.然后H5的js从url中获取到需要的参数,拼接到ajax请求的url中. 3.H5ajax请求,页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekaRD4.html" rel="bookmark" class="title">Java常见异常</a>
					<div>
						在Java中提供了一些异常用来描述经常发生的错误,对于这些异常,有的需要程序员进行捕获处理或声明抛出,有的是由Java虚拟机自动进行捕获处理.Java中常见的异常类如下表: 异 常 类 说 明 Cla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rzrx93.html" rel="bookmark" class="title">北京VR视频外包团队：全景VR视频科普</a>
					<div>
						近期很多用户资讯问关于全景视频,这里动点给大家介绍一下: 首先,全景360VR视频(全景视频使用VR设备控制)是一种特殊的视频形式,与普通视频的最大区别就是,全景视频的每一帧都是涵盖360度空间场景信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvwq13.html" rel="bookmark" class="title">javascript之Boolean</a>
					<div>
						一.new Boolean(value); //构造函数 Boolean(value); //转换函数 0,NaN,null,&quot;&quot;,undefined都会转成false,其他都会返 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBRnL4.html" rel="bookmark" class="title">angularjs--加载数据默认选中option</a>
					<div>
						最近在工作遇到一个问题,项目是用angularjs做的. 项目有一个需求是需要编辑资料,资料中有一个地方是有下拉框的.学艺不精的在下,在开始想到的是直接将给div添加ng-model,HTML代码如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1DyW3.html" rel="bookmark" class="title">ＭｙＳＱＬ主从复制从库状态监测</a>
					<div>
						MYSQLPORT=`netstat -na|grep &quot;LISTEN&quot;|grep &quot;3306&quot;|awk -F[:&quot; &quot;]+ '{print ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDqR60.html" rel="bookmark" class="title">我的android学习经历24</a>
					<div>
						Fragment生命周期 1.onAttach() 2.onCreate() 3.onCreateView() 4.onActivityCreated() 5.onStart() 6.onResume ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OXKLo4.html" rel="bookmark" class="title">powerpc平台移植zebra或quagga-0&period;99&period;23</a>
					<div>
						1,先configure ./configure   --enable-vtysh --disable-bgpd --disable-ripd --disable-ripngd --disable-o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rqP1M.html" rel="bookmark" class="title">（四）JS学习笔记 - 模式 - 观察者模式</a>
					<div>
						理解观察者模式 简单的讲,一个对象作为特定任务或是另一对象的活动的观察者,并且在这个任务或活动发生时,利用事件的形式通知观察者. 观察者的使用场合 当一个对象的改变需要同时改变其它对象,并且它不知道具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q8kpN0.html" rel="bookmark" class="title">2015新年之初发生了什么事</a>
					<div>
						@20150219 苍蝇们醉生梦死,粪堆里歌舞升平,几只跳蚤装腔作势地说着忽悠蜜蜂.蚂蚁们的反腐臭故事并在粪堆上洒着香水,劣质香水被洒在经年干屎上,滋滋地冒出一股股白气,形成一股莫名其妙的混合怪味.肥 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
